/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ TuCPU ]
 *
 *	RHG
 *	  2002.05.07		CCPURAɍđΉ
 */

#include "xm7.h"
#include "subctrl.h"
#include "mainetc.h"
#include "device.h"
#include "event.h"

/*
 *	O[o [N
 */
cpu6809_t subcpu;						/* TuCPUWX^ */

/*
 *	vg^Cv錾
 */
void sub_reset(void);
void sub_line(void);
void sub_exec(void);
BOOL subcpu_event(void);

/*
 *	TuCPU
 *	
 */
BOOL FASTCALL subcpu_init(void)
{
	subcpu.readmem = submem_readb;
	subcpu.writemem = submem_writeb;

	return TRUE;
}

/*
 *	TuCPU
 *	N[Abv
 */
void FASTCALL subcpu_cleanup(void)
{
	return;
}

/*
 *	TuCPU
 *	Zbg
 */
void FASTCALL subcpu_reset(void)
{
	sub_reset();
}

/*
 *	TuCPU
 *	Pss
 */
void FASTCALL subcpu_execline(void)
{
	sub_line();
}
/*
 *	TuCPU
 *	s
 */
void FASTCALL subcpu_exec(void)
{
	sub_exec();
}

/*
 *	TuCPU
 *	NMI荞ݐݒ
 */
void FASTCALL subcpu_nmi(void)
{
	if (subcpu.intr & INTR_SLOAD){
		subcpu.intr |= INTR_NMI;
	}
}

/*
 *	TuCPU
 *	FIRQ荞ݐݒ
 */
void FASTCALL subcpu_firq(void)
{
	if (!key_irq_mask) {
		/* CCPUɂȂĂꍇ́A荞݂Ȃ */
		subcpu.intr &= ~INTR_FIRQ;
	}
	else {
		/* L[荞݂̗Lŕ */
		if (key_irq_flag) {
			subcpu.intr |= INTR_FIRQ;
		}
		else {
			subcpu.intr &= ~INTR_FIRQ;
		}
	}
}

/*
 *	TuCPU
 *	IRQ荞ݐݒ
 */
void FASTCALL subcpu_irq(void)
{
	/* LZIRQ */
	if (subcancel_flag) {
		subcpu.intr |= INTR_IRQ;
	}
	else {
		subcpu.intr &= ~INTR_IRQ;
	}
}

/*
 *	TuCPU
 *	Z[u
 */
BOOL FASTCALL subcpu_save(int fileh)
{
	/* vbgtH[Ƃ̃pbLO邽߁A */
	if (!file_byte_write(fileh, subcpu.cc)) {
		return FALSE;
	}

	if (!file_byte_write(fileh, subcpu.dp)) {
		return FALSE;
	}

	if (!file_word_write(fileh, subcpu.acc.d)) {
		return FALSE;
	}

	if (!file_word_write(fileh, subcpu.x)) {
		return FALSE;
	}

	if (!file_word_write(fileh, subcpu.y)) {
		return FALSE;
	}

	if (!file_word_write(fileh, subcpu.u)) {
		return FALSE;
	}

	if (!file_word_write(fileh, subcpu.s)) {
		return FALSE;
	}

	if (!file_word_write(fileh, subcpu.pc)) {
		return FALSE;
	}

	if (!file_word_write(fileh, subcpu.intr)) {
		return FALSE;
	}

	if (!file_word_write(fileh, subcpu.cycle)) {
		return FALSE;
	}

	if (!file_word_write(fileh, subcpu.total)) {
		return FALSE;
	}

	return TRUE;
}

/*
 *	TuCPU
 *	[h
 */
BOOL FASTCALL subcpu_load(int fileh, int ver)
{
	/* o[W`FbN */
	if (ver < 200) {
		return FALSE;
	}

	/* vbgtH[Ƃ̃pbLO邽߁A */
	if (!file_byte_read(fileh, &subcpu.cc)) {
		return FALSE;
	}

	if (!file_byte_read(fileh, &subcpu.dp)) {
		return FALSE;
	}

	if (!file_word_read(fileh, &subcpu.acc.d)) {
		return FALSE;
	}

	if (!file_word_read(fileh, &subcpu.x)) {
		return FALSE;
	}

	if (!file_word_read(fileh, &subcpu.y)) {
		return FALSE;
	}

	if (!file_word_read(fileh, &subcpu.u)) {
		return FALSE;
	}

	if (!file_word_read(fileh, &subcpu.s)) {
		return FALSE;
	}

	if (!file_word_read(fileh, &subcpu.pc)) {
		return FALSE;
	}

	if (!file_word_read(fileh, &subcpu.intr)) {
		return FALSE;
	}

	if (!file_word_read(fileh, &subcpu.cycle)) {
		return FALSE;
	}

	if (!file_word_read(fileh, &subcpu.total)) {
		return FALSE;
	}

	return TRUE;
}
