/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ Win32API TuEChE ]
 */

#ifdef _WIN32

#ifndef _w32_sub_h_
#define _w32_sub_h_

/*
 *	TuEChE`
 */
#define SWND_BREAKPOINT			0		/* u[N|Cg */
#define SWND_SCHEDULER			1		/* XPW[ */
#if XM7_VER == 1
#define SWND_CPUREG_MAIN		2		/* CPUWX^ C(6809) */
#define SWND_CPUREG_SUB			3		/* CPUWX^ Tu */
#define SWND_CPUREG_JSUB		4		/* CPUWX^ {Tu */
#define SWND_CPUREG_Z80			5		/* CPUWX^ C(Z80) */
#define SWND_DISASM_MAIN		6		/* tAZu C(6809) */
#define SWND_DISASM_SUB			7		/* tAZu Tu */
#define SWND_DISASM_JSUB		8		/* tAZu {Tu */
#define SWND_DISASM_Z80			9		/* tAZu C(Z80) */
#define SWND_MEMORY_MAIN		10		/* _v C */
#define SWND_MEMORY_SUB			11		/* _v Tu */
#define SWND_MEMORY_JSUB		12		/* _v {Tu */
#define SWND_MEMORY_4			13		/* _v 4 */
#define SWND_FDC				14		/* FDC */
#define SWND_OPNREG				15		/* OPNWX^ */
#define SWND_OPNDISP			16		/* OPNfBXvC */
#define SWND_SUBCTRL			17		/* TuCPURg[ */
#define SWND_KEYBOARD			18		/* L[{[h */
#define SWND_MMR				19		/* MMR */
#define SWND_PALETTE			20		/* pbgWX^ */
#define SWND_BMC				21		/* ouRg[ */
#define SWND_MAXNUM				22
#else
#define SWND_CPUREG_MAIN		2		/* CPUWX^ C */
#define SWND_CPUREG_SUB			3		/* CPUWX^ Tu */
#define SWND_DISASM_MAIN		4		/* tAZu C */
#define SWND_DISASM_SUB			5		/* tAZu Tu */
#define SWND_DISASM_3			6		/* tAZu 3 */
#define SWND_DISASM_4			7		/* tAZu 4 */
#define SWND_MEMORY_MAIN		8		/* _v C */
#define SWND_MEMORY_SUB			9		/* _v Tu */
#define SWND_MEMORY_3			10		/* _v 3 */
#define SWND_MEMORY_4			11		/* _v 4 */
#define SWND_FDC				12		/* FDC */
#define SWND_OPNREG				13		/* OPNWX^ */
#define SWND_OPNDISP			14		/* OPNfBXvC */
#define SWND_SUBCTRL			15		/* TuCPURg[ */
#define SWND_ALULINE			16		/* _Z/ */
#define SWND_KEYBOARD			17		/* L[{[h */
#define SWND_MMR				18		/* MMR */
#define SWND_PALETTE			19		/* pbgWX^ */
#if XM7_VER >= 3
#define	SWND_DMAC				20		/* DMAC */
#define SWND_MAXNUM				21		/* őTuEChE */
#else
#define SWND_MAXNUM				20		/* őTuEChE */
#endif
#endif

#define	MAXDISVIEW				4		/* őtAZuEChE */
#define	MAXDMPVIEW				4		/* ő僁gEChE */


#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
void FASTCALL InitSubWndWork(void);
										/* TuEBhE[N */

HWND FASTCALL CreateBreakPoint(HWND hParent, int index);
										/* u[N|CgEChE 쐬 */
void FASTCALL RefreshBreakPoint(void);
										/* u[N|CgEChE tbV */
HWND FASTCALL CreateScheduler(HWND hParent, int index);
										/* XPW[EChE 쐬 */
void FASTCALL RefreshScheduler(void);
										/* XPW[EChE tbV */
HWND FASTCALL CreateCPURegister(HWND hParent, BYTE nCPU, int index);
										/* CPUWX^EChE 쐬 */
void FASTCALL RefreshCPURegister(void);
										/* CPUWX^EChE tbV */
HWND FASTCALL CreateDisAsm(HWND hParent, BYTE nCPU, int index);
										/* tAZuEChE 쐬 */
void FASTCALL RefreshDisAsm(void);
										/* tAZuEChE tbV */
void FASTCALL AddrDisAsm(BYTE nCPU, DWORD dwAddr);
										/* tAZuEChE AhXw */
HWND FASTCALL CreateMemory(HWND hParent, BYTE nCPU, int index);
										/* _vEChE 쐬 */
void FASTCALL RefreshMemory(void);
										/* _vEChE tbV */
void FASTCALL AddrMemory(BYTE nCPU, DWORD dwAddr);
										/* _vEChE AhXw */

HWND FASTCALL CreateFDC(HWND hParent, int index);
										/* FDCEChE 쐬 */
void FASTCALL RefreshFDC(void);
										/* FDCEChE tbV */
#if XM7_VER ==1 && defined(BUBBLE)
HWND FASTCALL CreateBMC(HWND hParent, int index);
										/* BMCEChE 쐬 */
void FASTCALL RefreshBMC(void);
										/* BMCEChE tbV */
#endif
HWND FASTCALL CreateOPNReg(HWND hParent, int index);
										/* OPNWX^EChE 쐬 */
void FASTCALL RefreshOPNReg(void);
										/* OPNWX^EChE tbV */
void FASTCALL ReSizeOPNReg(void);
										/* OPNWX^EChE TCY */
HWND FASTCALL CreateSubCtrl(HWND hParent, int index);
										/* TuCPURg[EChE 쐬 */
void FASTCALL RefreshSubCtrl(void);
										/* TuCPURg[EChE tbV */
HWND FASTCALL CreateALULine(HWND hParent, int index);
										/* _Z/ԃEChE 쐬 */
void FASTCALL RefreshALULine(void);
										/* _Z/ԃEChE tbV */
HWND FASTCALL CreateOPNDisp(HWND hParent, int index);
										/* OPNfBXvCEChE 쐬 */
void FASTCALL RefreshOPNDisp(void);
										/* OPNfBXvCEChE tbV */
void FASTCALL ReSizeOPNDisp(void);
										/* OPNfBXvCEChE TCY */
HWND FASTCALL CreateKeyboard(HWND hParent, int index);
										/* L[{[hEChE 쐬 */
void FASTCALL RefreshKeyboard(void);
										/* L[{[hEChE tbV */
HWND FASTCALL CreateMMR(HWND hParent, int index);
										/* MMREChE 쐬 */
void FASTCALL RefreshMMR(void);
										/* MMREChE tbV */
#if XM7_VER >= 3
HWND FASTCALL CreateDMAC(HWND hParent, int index);
										/* DMACEChE 쐬 */
void FASTCALL RefreshDMAC(void);
										/* DMACEChE tbV */
#endif
HWND FASTCALL CreatePaletteReg(HWND hParent, int index);
										/* pbgWX^EChE 쐬 */
void FASTCALL RefreshPaletteReg(void);
										/* pbgWX^EChE tbV */

/*
 *	ėp[`
 */
void FASTCALL DrawWindowText(HDC hDC, BYTE *ptr, int x, int y);
										/* eLXg` */
void FASTCALL DrawWindowText2(HDC hDC, BYTE *ptr, int x, int y);
										/* eLXg`(]t) */
void FASTCALL DestroySubWindow(HWND hWnd, BYTE **pBuf, HMENU hmenu);
										/* TuEChEDestroy */
void FASTCALL PositioningSubWindow(HWND hParent, LPRECT rect, int index);
										/* TuEBhEʒuZo */

/*
 *	v[N
 */
extern HWND hSubWnd[SWND_MAXNUM];
										/* TuEChE */
extern BOOL bShowSubWindow[SWND_MAXNUM];
										/* TuEChE\ */
extern BOOL bPopupSwnd;
										/* TuEBhE|bvAbv */
extern BOOL bPaletteRefresh;
										/* pbgtbV */
extern BOOL bMultiPageRefresh;
										/* }`y[WtbV */
#ifdef __cplusplus
}
#endif

#endif	/* _w32_sub_h_ */
#endif	/* _WIN32 */
